# -*- coding: utf-8 -*-
from setuphelpers import *
from setupdevhelpers import *
import requests


def update_package():
    # Déclaration des variables locales
    package_updated = False
    proxies = get_proxies_from_wapt_console()
    if not proxies:
        proxies = get_proxies()
    arch_dict = {
        "x64":"win64-mingw.exe",
        
    }    

    url = "https://sourceforge.net/projects/gnuplot/files/gnuplot/"
    response = requests.get(url)
    headers = bs_find_all(url,"th","headers")

    if headers:
        first_header = headers[0]
        a_tag = first_header.find("a")
        if a_tag:
            first_link = a_tag['href']
            version = first_link.split('/')[-2]
            print(f"First version found: {version}")

    # Suppression des points dans la version pour correspondre au format du fichier binaire
    version_no_dots = version.replace(".", "")
    print(f"Version sans points : {version_no_dots}") 
    latest_bin  = f"gp{version_no_dots}-win64-mingw.exe"
    download_url = f"https://kumisystems.dl.sourceforge.net/project/gnuplot/gnuplot/{version}/" + latest_bin
    
    # Downloading latest binaries
    print("Download URL is: %s" % download_url)
    if not isfile(latest_bin):
        print("Downloading: %s" % latest_bin)
        wget(download_url, latest_bin,proxies=proxies)
    else:
        print("Binary is present: %s" % latest_bin)

    

    # Changing version of the package
    if Version(version, 4) > Version(control.get_software_version(), 4):
        print("Software version updated (from: %s to: %s)" % (control.get_software_version(), Version(version)))
        package_updated = True
    else:
        print("Software version up-to-date (%s)" % Version(version))
    control.set_software_version(version)
    control.save_control_to_wapt()

    # Validating update-package-sources
    return package_updated

    # # Changing version of the package and validating update-package-sources
    # return complete_control_version(control, version)
